<?php
class ControllerExtensionMtTbigrCreditTbigr extends Controller {
	
	public function TBIGR_PMT($rate, $nper, $pv, $fv=0, $type = 0) {
		return (-$fv - $pv * pow(1 + $rate, $nper)) / (1 + $rate * $type) / ((pow(1 + $rate, $nper) - 1) / $rate);
	}
			
	public function index() {
		$this->load->language('extension/mt_tbigr_credit/tbigr');

		if (isset($this->request->get['order_id'])) {
			$order_id = (string)$this->request->get['order_id'];
		} else {
			$order_id = 0;
		}
		
		if (isset($this->request->get['type'])) {
			$type = $this->request->get['type'];
		} else {
			$type = 'TBI';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_tbigr'),
			'href' => $this->url->link("extension/mt_tbigr_credit/tbigr&order_id=$order_id&type=$type", '', '')
		);
		
		$tbigr_send = $this->session->data['tbigr_send'];
		
		if ($tbigr_send == 'Yes'){
			$this->session->data['tbigr_send'] = 'No';
			// Proceed to TBI Process	
			$data['TBIGR_LIVEURL'] = 'https://calc.tbibank.gr';
			$tbigr_unicid = $this->config->get('mt_tbigr_credit_unicid');
			$tbigr_store_id = $this->config->get('mt_tbigr_credit_storeid');
			$tbigr_username = $this->config->get('mt_tbigr_credit_username');
			$tbigr_password = $this->config->get('mt_tbigr_credit_password');
			$tbigr_iris_iban = $this->config->get('mt_tbigr_credit_iris_iban');
			$tbigr_iris_key = $this->config->get('mt_tbigr_credit_iris_key');
			$tbigr_url = $data['TBIGR_LIVEURL'] . "/function/status.php";
			$tbigr_cnp = '';
			$tbigr_person_type = '';
			$tbigr_net_income = '';
			$tbigr_instalments = '';
	
			$this->load->model('account/order');
			$this->load->model('catalog/product');
			$this->load->model('tool/image');
			$this->load->model('catalog/category');
			$products = $this->model_account_order->getOrderProducts($order_id);
			$order = $this->model_account_order->getOrder($order_id);
			$tbigr_fname = isset($order['firstname']) ? $order['firstname'] : '';
			$tbigr_lname = isset($order['lastname']) ? $order['lastname'] : '';
			$tbigr_phone = isset($order['telephone']) ? $order['telephone'] : '';
			$tbigr_email = isset($order['email']) ? $order['email'] : '';
			$tbigr_billing_address = isset($order['payment_address_1']) ? $order['payment_address_1'] : '';
			$tbigr_billing_city = isset($order['payment_city']) ? $order['payment_city'] : '';
			$tbigr_billing_county = isset($order['payment_zone']) ? $order['payment_zone'] : '';
			$tbigr_shipping_address = isset($order['shipping_address_1']) ? $order['shipping_address_1'] : '';
			$tbigr_shipping_city = isset($order['shipping_city']) ? $order['shipping_city'] : '';
			$tbigr_shipping_county = isset($order['shipping_zone']) ? $order['shipping_zone'] : '';
			$tbigr_total = isset($order['total']) ? $order['total'] : '';
	
			$ident = 0;
			$tbigr_items = array();
			$tbigr_api_items = array();
			foreach ($products as $product){
				$productnew = $this->model_catalog_product->getProduct($product['product_id']);
				$products_cat = $this->model_catalog_product->getCategories($product['product_id']);
				$tbigr_items[$ident]['name'] = preg_replace("/[^A-Za-z0-9?! ]/","",$product['name']);
				$tbigr_api_items[$ident]['name'] = $tbigr_items[$ident]['name'];
				$tbigr_api_items[$ident]['description'] = '';
				$tbigr_quantity = $product['quantity'];
				$tbigr_items[$ident]['qty'] = "$tbigr_quantity";
				$tbigr_api_items[$ident]['qty'] = "$tbigr_quantity";
				$tbigr_price = (float)$product['price'];
				$tbigr_items[$ident]['price'] = "$tbigr_price";
				$tbigr_api_items[$ident]['price'] = "$tbigr_price";
				foreach ($products_cat as $product_cat){
					$tbigr_category = $product_cat['category_id'];
					$tbigr_items[$ident]['category'] = "$tbigr_category";
					$tbigr_api_items[$ident]['category'] = "$tbigr_category";
				}
				$tbigr_product_id = $product['product_id'];
				$tbigr_items[$ident]['sku'] = "$tbigr_product_id";
				$tbigr_api_items[$ident]['sku'] = "$tbigr_product_id";
				$tbigr_items[$ident]['ImageLink'] = $this->model_tool_image->resize($productnew['image'], 800, 600);
				$tbigr_api_items[$ident]['ImageLink'] = $this->model_tool_image->resize($productnew['image'], 800, 600);
				$ident++;
			}

			$tbigr_ch = curl_init();
			curl_setopt($tbigr_ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($tbigr_ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($tbigr_ch, CURLOPT_MAXREDIRS, 2);
			curl_setopt($tbigr_ch, CURLOPT_TIMEOUT, 5);
			curl_setopt($tbigr_ch, CURLOPT_URL, $data['TBIGR_LIVEURL'] . '/function/getparameters.php?cid='.$tbigr_unicid);
			$paramstbigr = json_decode(curl_exec($tbigr_ch), true);
			curl_close($tbigr_ch);
	
			// Create tbigr order i data base
			$tbigr_post = array(
				'store_id'      => $tbigr_store_id,
				'order_id'      =>  $order_id,
				'back_ref'      =>  $tbigr_url,
				'order_total'   =>  $tbigr_total,
				'username'	=> $tbigr_username,
				'password'	=> $tbigr_password,
				'type'		=> strtoupper($type),
				'customer'      =>  array(
					'fname'         => $tbigr_fname,
					'lname'         => $tbigr_lname,
					'cnp'           => $tbigr_cnp, 
					'email'         => $tbigr_email,
					'phone'         => $tbigr_phone,
					'billing_address'      => $tbigr_billing_address,
					'billing_city'          => $tbigr_billing_city,
					'billing_county'        => $tbigr_billing_county,
					'shipping_address'      => $tbigr_shipping_address,
					'shipping_city'          => $tbigr_shipping_city,
					'shipping_county'        => $tbigr_shipping_county,
					'person_type'   => $tbigr_person_type,
					'net_income'    => $tbigr_net_income,
					'instalments'	=> $tbigr_instalments
				),
				'items' => $tbigr_items
			);
		
			$tbigr_add_ch = curl_init();
			curl_setopt($tbigr_add_ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($tbigr_add_ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($tbigr_add_ch, CURLOPT_MAXREDIRS, 2);
			curl_setopt($tbigr_add_ch, CURLOPT_TIMEOUT, 5);
			curl_setopt($tbigr_add_ch, CURLOPT_URL, $data['TBIGR_LIVEURL'] . '/function/addorders.php?cid='.$tbigr_unicid);
			curl_setopt($tbigr_add_ch, CURLOPT_POST, 1);
			curl_setopt($tbigr_add_ch, CURLOPT_POSTFIELDS, http_build_query($tbigr_post));
			$paramstbigradd=json_decode(curl_exec($tbigr_add_ch), true);
			curl_close($tbigr_add_ch);				
			// Create tbigr order i data base

			$send_redy = "No";
			if (isset($paramstbigradd['status']) && ($paramstbigradd['status'] == 'Yes')){
				// save to tbiorders file
				$tbigr_tempcontent = file_get_contents(DIR_APPLICATION . "view/theme/default/image/keys/tbigrorders.json");
				if ($tbigr_tempcontent != false){
					$tbigr_orders = json_decode($tbigr_tempcontent);
					// test over 1000
					if (is_array($tbigr_orders) && (count($tbigr_orders) >= 1000)){
						array_shift($tbigr_orders);
					}
					$tbigr_order_current = array(
						"order_id" => $order_id,
						"order_status" => "Draft"
					);
					$key = array_search($order_id, array_map(
						function($o) {
							return $o->order_id;
						}, 
						$tbigr_orders));
					if ($key === false){
						array_push($tbigr_orders, $tbigr_order_current);
					}
					$jsondata = json_encode($tbigr_orders);
					file_put_contents(DIR_APPLICATION . "view/theme/default/image/keys/tbigrorders.json", $jsondata);
				}
				
				// send to softinteligens
				$tbigr_post_arr = array(
					'firstname'      	=> $tbigr_fname,
					'lastname'      	=> $tbigr_lname,
					'surname'      		=> '',
					'pin'   			=> $tbigr_cnp,
					'origin'			=> 'POS_Online',
					'resellercode'		=> $tbigr_store_id,
					'email'         	=> $tbigr_email,
					'phone'         	=> $tbigr_phone,
					'billingaddress'	=> array(
						'country'			=> '',
						'county'        	=> $tbigr_billing_county,
						'city'         	 	=> $tbigr_billing_city,
						'streetname'      	=> $tbigr_billing_address,
						'streetno'			=> '',
						'buildingno'		=> '',
						'entranceno'		=> '',
						'floorno'			=> '',
						'apartmentno'		=> '',
						'postalcode'		=> ''
					),
					'deliveryaddress'	=> array(
						'country'			=> '',
						'county'        	=> $tbigr_shipping_county,
						'city'         	 	=> $tbigr_shipping_city,
						'streetname'      	=> $tbigr_shipping_address,
						'streetno'			=> '',
						'buildingno'		=> '',
						'entranceno'		=> '',
						'floorno'			=> '',
						'apartmentno'		=> '',
						'postalcode'		=> ''
					),
					'orderid'   		=> $paramstbigradd['newid'],
					'bankingproductcode'=> '',
					'promo'				=> '0',
					'installments'		=> $tbigr_instalments,
					'ordertotal'		=> $tbigr_total,
					'installmentamount'	=> '',
					'items' 			=> $tbigr_api_items,
					'siteurl'			=> $data['TBIGR_LIVEURL'],
					'statusurl'			=> $tbigr_url
				);
				
				// send to IRIS
				$tbigriris_post_arr = array(
					'currency'      	=> 'EUR',
					'description'      	=> 'TBI IRIS Payment',
					'hookUrl'      		=> $tbigr_url . '?order=' . $paramstbigradd['newid'],
					'name'   			=> '',
					'redirectUrl'		=> $this->url->link('checkout/cart'),
					'sum'				=> number_format($tbigr_total, 2, ".", ""),
					'toIban'         	=> $tbigr_iris_iban
				);
						
				if (strtoupper($type) == 'TBI'){
					if ($paramstbigr['tbi_testenv'] == 1){
						$tbigr_envurl = $paramstbigr['tbi_testurl'];
						$tbigr_ocp = '1f0a04a6ad7a4dac80c664706fdcb93c';
					}else{
						$tbigr_envurl = $paramstbigr['tbi_liveurl'];
						$tbigr_ocp = 'd2304c1fe5de43d8837d081192a9a39b';
					}
					$tbigr_post = $tbigr_post_arr;
				}else{
					if ($paramstbigr['iris_testenv'] == 1){
						$tbigr_envurl = $paramstbigr['iris_testurl'];
						$tbigr_ocp = '';
					}else{
						$tbigr_envurl = $paramstbigr['iris_liveurl'];
						$tbigr_ocp = '';
					}
					$tbigr_post = $tbigriris_post_arr;
				}
				
				$this->cart->clear();				
				$send_redy = "Yes";
			}

			// Proceed to TBI Process	

			$data['heading_title'] = $this->language->get('heading_title');
			$data['column_left'] = $this->load->controller('common/column_left');
			$data['column_right'] = $this->load->controller('common/column_right');
			$data['content_top'] = $this->load->controller('common/content_top');
			$data['content_bottom'] = $this->load->controller('common/content_bottom');
			$data['footer'] = $this->load->controller('common/footer');
			$data['header'] = $this->load->controller('common/header');
			$data['order_id'] = $order_id;
			$data['send_redy'] = $send_redy;
			$data['tbigr_encrypt'] = json_encode($tbigr_post, JSON_UNESCAPED_UNICODE);
			$data['tbigr_envurl'] = $tbigr_envurl;
			$data['tbi_pause_txt'] = $paramstbigr['tbi_pause_txt'];
			$data['tbigrlogo'] = 'catalog/view/theme/default/image/keys/tbigr_logo.jpg';
			$data['tbigr_username'] = $tbigr_username;
			$data['tbigr_password'] = $tbigr_password;
			$data['text_problem'] = $this->language->get('text_problem');
			$data['type'] = strtoupper($type);
			$data['tbigr_iris_key'] = $tbigr_iris_key;
			$data['tbigr_ocp'] = $tbigr_ocp;

			$this->response->setOutput($this->load->view('extension/mt_tbigr_credit/tbigr', $data));
		}else{
			echo $this->language->get('text_interrupt') . ' - <a href="/">Shop</a>';
		}
	}
	
	public function updateOrder(){
		$json = array();
		$json['success'] = 'unsuccess';
		
		$tbigr_unicid = $this->config->get('mt_tbigr_credit_unicid');
		
		if (isset($this->request->post['order_id'])) {
			$tbigr_order_id = $this->request->post['order_id'];
		} else {
			$tbigr_order_id = '';
		}
		
		if (isset($this->request->post['status'])) {
			$tbigr_status = $this->request->post['status'];
		} else {
			$tbigr_status = '';
		}
		
		if (isset($this->request->post['calculator_id'])) {
			$tbigr_calculator_id = $this->request->post['calculator_id'];
		} else {
			$tbigr_calculator_id = '';
		}
		
		if (($tbigr_calculator_id != '') && ($tbigr_unicid == $tbigr_calculator_id)){
			if (file_exists(DIR_APPLICATION . "view/theme/default/image/keys/tbigrorders.json")) {
				$orderdata = file_get_contents(DIR_APPLICATION . "view/theme/default/image/keys/tbigrorders.json");
				$tbigr_orderdata_all = json_decode($orderdata, true);
				foreach ($tbigr_orderdata_all as $key => $value){
					if ($tbigr_orderdata_all[$key]['order_id'] == $tbigr_order_id){
						$tbigr_orderdata_all[$key]['order_status'] = $tbigr_status;
					}
				}
				$jsondata = json_encode($tbigr_orderdata_all);
				file_put_contents(DIR_APPLICATION . "view/theme/default/image/keys/tbigrorders.json", $jsondata);
				$json['success'] = 'success';
			}
		}
		$json['tbigr_order_id'] = $tbigr_order_id;
		$json['tbigr_status'] = $tbigr_status;
		$json['tbigr_calculator_id'] = $tbigr_calculator_id;
		
		$this->response->addHeader('Content-Type: application/json');
		$this->response->addHeader('Access-Control-Allow-Origin: https://calc.tbibank.gr');
		$this->response->setOutput(json_encode($json));
	}
}
